<template>
  <form class="vee-form" @submit="onSubmit">
    <component
      v-for="(field, i) in fieldsInternal"
      :key="i"
      :is="component(field.type)"
      :formName="name"
      :field="field"
      :field-prefix="fieldPrefix"
      :modelState="modelState"
      :busy="busy"
      @button="onComponentButton"
      @input="onComponentInput"
      @field-input="onComponentFieldInput"
      @submit="onSubmit"
      @load-state="onLoadState"
      @save-state="onSaveState"
    />

    <div class="row mb-3" v-if="error">
      <div class="col-12">
        <div class="text-danger">
          <i class="bi bi-bug-fill"></i>
          {{ error }}
        </div>
      </div>
    </div>

    <div class="d-flex justify-content-between mb-3" v-if="buttonText || routeText">
      <div>
        <router-link :to="route" v-if="route">{{ routeText }}</router-link>
      </div>
      <div>
        <button type="button" class="btn btn-primary" @click="onSubmit" :disabled="disabled">
          <span v-if="validating">
            <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
            Validating...
          </span>
          <span v-else-if="busy">
            <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
            {{ busyButtonText }}
          </span>
          <span v-else>
            <i aria-hidden="true" :class="buttonIconClass"></i>
            {{ buttonText }}
          </span>
        </button>
      </div>
    </div>
  </form>
</template>

<script>
import { ref, computed, watch } from 'vue'
import { useStore } from 'vuex'
import { useVForm } from '../../plugins/vform-plugin.js'

export default {
  name: 'VForm',
  emits: ['button', 'input', 'fieldInput', 'submit'],
  props: {
    // Controls
    name: { type: String, required: true },
    fields: { type: Array, required: true },

    // This would be taken from the API response if validation fails at the server
    modelState: { type: Object, default: null },

    // Form
    buttonText: { type: String, default: '' },
    buttonIconClass: { type: String, default: '' },
    busy: { type: Boolean, default: false },
    busyButtonText: { type: String, default: '' },

    // Optional link next to the button
    route: { type: Object, default: null },
    routeText: { type: String, default: '' },

    // General
    // A general error shown when it's not asscociated with any one field
    error: { type: String, default: '' },
  },
  setup(props, context) {
    const store = useStore()
    const vform = useVForm()

    const validating = ref(false)
    const fieldsInternal = ref(JSON.parse(JSON.stringify(props.fields)))

    const disabled = computed(() => {
      return props.busy || validating.value
    })

    const fieldPrefix = computed(() => {
      return props.name + '_'
    })

    // The request object returned by this component (to be used in an API call).
    const form = computed(() => {
      const form = {}
      fieldsInternal.value.forEach(function (field) {
        form[field.name] = field.value
      })
      return form
    })

    const onComponentButton = (field) => {
      var fieldInternal = fieldsInternal.value.find((x) => x.name === field.name)
      fieldInternal.value = field.value
      context.emit('button', fieldInternal, fieldInternal.value)
    }

    const onComponentInput = (e) => {
      context.emit('input', e)
    }

    const onComponentFieldInput = (field) => {
      var fieldInternal = fieldsInternal.value.find((x) => x.name === field.name)
      fieldInternal.value = field.value
      context.emit('fieldInput', fieldInternal, fieldInternal.value)
    }

    const onSubmit = async (e) => {
      e?.preventDefault()
      validating.value = true
      const { result, mutatedFields } = await vform.validateAsync(fieldsInternal.value)
      validating.value = false
      fieldsInternal.value = JSON.parse(JSON.stringify(mutatedFields))
      if (result && !disabled.value) {
        context.emit('submit', form.value)
      }
    }

    const onLoadState = () => {
      if (!store.state.core.vformState || store.state.core.vformState.formName !== props.name) {
        return
      }

      updateFieldValues(store.state.core.vformState.form)

      // TODO: Restore the selection

      store.dispatch('core/setVformState', null)
    }

    const onSaveState = (field) => {
      const length = field.value ? field.value.length : 0
      const state = {
        formName: props.name,
        form: form.value,
        selectedField: field.name,
        selectionStart: length, // TODO: Get actual cursor position
        selectionEnd: length, // TODO: Get actual cursor position
      }
      store.dispatch('core/setVformState', state)
    }

    const component = (key) => {
      return vform.components[key] || vform.components[vform.defaultComponent]
    }

    const updateFieldValues = (form) => {
      Object.keys(form).forEach((key) => {
        const field = fieldsInternal.value.find((x) => x.name === key)
        field.value = form[key]
        context.emit('fieldInput', field, form)
      })
    }

    watch(
      () => props.fields,
      () => {
        fieldsInternal.value = JSON.parse(JSON.stringify(props.fields))
      }
    )

    return {
      validating,
      fieldsInternal,
      disabled,
      fieldPrefix,
      form,
      onComponentButton,
      onComponentInput,
      onComponentFieldInput,
      onSubmit,
      onLoadState,
      onSaveState,
      component,
    }
  },
}
</script>
